/**
 * 
 */
package com.icauda.article.pgm.tri.algo;

import org.junit.Before;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author thierry.leriche
 * 
 */
public class RapideViaListeTriTest extends AbstractTriTest {

	private static final Logger logger = LoggerFactory.getLogger(RapideViaListeTriTest.class);

	@Before
	public void doBefore() {
		logger.debug(LINE);
		tri = new RapideViaListeTri();
	}

	@Test
	public void testTri1() {

		logger.debug("testTri1");

		// Arrange
		final int[] tab = { 1, 7, 3, 2, 1, 3, 5, 6, 9 };

		// Act - assert
		doTestTri(tab);
	}

	@Test
	public void testTri2() {

		logger.debug("testTri2");

		// Arrange
		final int[] tab = { 8, 2, 3, 4, 5, 1, 7, 4, 9 };

		// Act - assert
		doTestTri(tab);
	}

	@Test
	public void testTri3() {

		logger.debug("testTri3");

		// Arrange
		final int[] tab = { 6, 5, 3, 2, 1, 4, 7, 8, 9 };

		// Act - assert
		doTestTri(tab);
	}

	@Test
	public void testTri4() {

		logger.debug("testTri4");

		// Arrange
		final int[] tab = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 };

		// Act - assert
		doTestTri(tab);
	}

	@Test
	public void testTri5() {

		super.testTriTabAvec1_000Elements();
	}

	@Test
	public void testTri6() {

		logger.debug("testTri6");

		// Arrange
		final int[] tab = { 0, 0, 1, 1, 1, 2, 2, 2, 3, 5, 6, 6, 11, 7, 7, 10, 8, 13, 20, 15, 15, 15, 16, 18, 30, 11, 11 };

		// Act - assert
		doTestTri(tab);
	}

	@Test
	public void testTri7() {

		logger.debug("testTri7");

		// Arrange
		final int[] tab = { 1, 2 };

		// Act - assert
		doTestTri(tab);
	}

	@Test
	public void testTri8() {

		logger.debug("testTri8");

		// Arrange
		final int[] tab = { 2, 1 };

		// Act - assert
		doTestTri(tab);
	}

	@Test
	public void testTri9() {

		logger.debug("testTri9");

		// Arrange
		final int[] tab = { 2, 1, 2 };

		// Act - assert
		doTestTri(tab);
	}

	@Test
	public void testTri10() {

		logger.debug("testTri10");

		// Arrange
		final int[] tab = { 1, 1, 1, 2, 3, 3, 1, 1, 1 };

		// Act - assert
		doTestTri(tab);
	}
}
